<template>
  <div>
    <!--<template>
      <hsc-window-style-white>
        <hsc-window
          style=" z-index:2000"
          :resizable="true"
          :isScrollable="true"
          :minHeight="300"
          :maxHeight="500"
          :minWidth="300"
          :maxWidth="400"
          title="Viewer Objects"
          :width="400"
          :height="700"
        >
          <json-view :data="$data.puntoContacto" />
        </hsc-window>
      </hsc-window-style-white>
    </template>-->
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Gerentes</strong>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <div class="titSec">Gerentes</div>
      <div class="CampoOblogario">
        Consulta el desempeño de un gerente
       
      </div>
      <br />
      <div class="gris">
        <v-row>
          <v-col class="pb-sm-0" :cols="12" :sm="12" :md="5" :lg="5" :xl="4">
            <div class="CampoOblogario">
                 Gerente
              <span class="tRojo">*</span>
             </div>
            <v-autocomplete
              v-model="searchGerente"
              :loading="isSearching"
              :items="metadata.gerentes"
              :search-input.sync="searchGerenteSync"
              clearable
              hide-no-data
              hide-details
              hide-selected
              item-text="gerente_descripcion"
              item-value="gerente"
              @change = "getPuntoContacto()"
              placeholder="Escribe su nombre o número de empleado"
              label="Buscar Gerente"
              solo
              return-object
            />
          </v-col>
          <v-col class="pt-sm-0" :cols="12" :sm="12" :md="4" :lg="3" :xl="2">
            <v-btn
              block
              class="mr-6 mt-md-3 mt-sm-0"
              depressed
              dark
              tile
              color="secundary"
              :class="[
                { desac: isLoadingPuntoContacto || !searchGerente }
              ]"
              @click="getPuntoContacto()"
              >Buscar Gerente</v-btn
            >
          </v-col>
        </v-row>
      </div>
     
      
      
     
      <template v-if="!isNoActivePuntoContacto || isPuntoContactoAsignado">
        <div class="titSec" v-show="infoPuntoContactoResult">Asignación de la franquicia</div>
        <div class="CampoOblogario" v-show="infoPuntoContactoResult">
          Campo requerido
          <span class="tRojo">*</span>
        </div>
        
      </template>
      
    </div>
    
    
  </div>
</template>
<script>
import { required } from "vuelidate/lib/validators";
import axios from "axios";
import store from "@/store";
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
export default {
  name: "Component-buscadorGerente",
  components: {
    
  },
  data() {
    return {
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Modelo de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia"
          }
        },
        {
          text: "Puntos de Contacto Home",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia_home_puntos_contacto"
          }
        },
        {
          text: "Gestión Puntos de Contacto",
          disabled: true
        }
      ],
      searchGerente: null,
      searchGerenteSync: null,
      metadata: {
        gerentes: [],
        franquicias: [],
        categoriasFranquicia: [],
        modelosFranquicia: [],
        formatosFranquicia: []
      },
      isSearching: false,
      isLoadingPuntoContacto: false,
      isLoadingGerentes: false,
      isLoadingFranquicia: false,
      isDialogErrorValidation: false,
      isDialogSave: false,
      isDialogCancel: false,
      isNotFoundPuntoContacto: false,
      isNoActivePuntoContacto: false,
      isSavingAsignacion: false,
      defaultDataPuntoContacto: null,
      puntoContactoBackup: null,
      infoPuntoContactoResult: false,
      gerente: {
        id_gerente: null,
        nombre_gerente: null,
    
      }
    };
  },
  
  watch: {
    searchGerenteSync(val) {
      if (!val) {
        this.searchGerente = null;
        this.invokeDefaultEmpyDataGerente();
      }
    }
  },
  computed: {
   
  },
  methods: {
    
    getGerentes() {
      var self = this;
      self.isLoadingGerentes = true;
      axios
        .get("/franquicia/dashboard/consulta/secure/buscador/get/gerente")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setGerentes(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isLoadingGerentes = false;
        });
    },
    setGerentes(data) {
      if (data) {
        data = data.filter((item, index) => {
          item.gerente_descripcion = item.id_gerente + " - " + item.nombre_gerente;
          return item;
        });
      }
      this.metadata.gerentes = data;
    },
      
    
    
    snapshotDataPuntoContacto() {
      let gerente = JSON.stringify(this.gerente);
      this.defaultDataPuntoContacto = JSON.parse(gerente);
    },
    invokeDefaultEmpyDataGerente() {
      let gerente = JSON.parse(
        JSON.stringify(this.defaultDataPuntoContacto)
      );
      this.gerente = gerente;
      this.$v.$reset();
    }
  },
  created() {
    this.snapshotDataPuntoContacto();
    this.getGerentes();
    
  },
  
};
</script>
